Ruby - Feature #11346

New #intern_str or similarly-named method of Symbol to return a cached, frozen string (like
"string".freeze)

07/12/2015 07:11 PM - stevej (Steve Jorgensen)

Status: Rejected

Priority: Normal

Assignee: matz (Yukihiro Matsumoto)
Target version:

Description

While | don't think it would be a good idea to change the behavior of the existing Symbol#to_s method as suggested in issue 11066, |
think that it would be extremely useful to have some instance method of Symbol to perform that operation.

If such a method is added, it might be nice if String, and maybe even Object offered the same method so the operation could be
performed with indifference to the target and so optimizations could be applied to Classes other than just Symbol (e.g. NilClass,
TrueClass, FalseClass, and maybe for smallish values of Fixnum).

Perhaps, the new method name would be #intern_str, and if that is added to Object, the default implementation could be something
like to_s.intern_str which would abide by the contract of always returning the same frozen string object (assuming #to_s does), even
though it builds an ordinary string as an intermediate object, so is not optimized.

Related issues:
Related to Ruby - Feature #11066: symbol.to_s performance - caching and retur... Rejected

History

#1 - 07/12/2015 08:18 PM - stevej (Steve Jorgensen)

In the description, "(assuming #to_s does)" should read "(assuming #to_s returns equivalent strings)".

#2 - 07/13/2015 03:13 AM - nobu (Nobuyoshi Nakada)

- Related to Feature #11066: symbol.to_s performance - caching and returning a frozen string added

#3 - 08/21/2015 03:31 PM - ko1 (Koichi Sasada)

- Assignee set to matz (Yukihiro Matsumoto)

Any opinion?

#4 - 10/21/2021 11:06 PM - jeremyevans0 (Jeremy Evans)
- Status changed from Open to Closed

Symbol#name was added in Ruby 3.0 for this.

#5 - 12/13/2021 01:50 AM - ko1 (Koichi Sasada)

- Status changed from Closed to Rejected
